//3456789_123456789_123456789_123456789_123456789_123456789_123456789_123456789_
//
// P2H.h: interface for CP2H class.
//
// P2H holds a homography for Projective 2D space, a 3x3 H matrix that applies
// projective transformations to CP2Point and CP2Line objects, which are 
// 3x1 column vectors.
//
////////////////////////////////////////////////////////////////////////////////
#if !defined(AFX_P2H_H__3A29892F_664D_4E51_82CA_155EF7D6824B__INCLUDED_)
#define AFX_P2H_H__3A29892F_664D_4E51_82CA_155EF7D6824B__INCLUDED_

#include "IBMRvecmat.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CP2H  
//==============================================================================
// A point homography for projective 2-D space; a 3x3 matrix that applies to
// point vectors expressed as a column vector [x1,x2,x3], where the 2D position
// of the point is (x1/x3, x2/x3).
{
public:
	Mat3 m_H;	
	
	CP2H();									// default constructor,
	virtual ~CP2H();						// default destructor.

};

#endif // !defined(AFX_P2H_H__3A29892F_664D_4E51_82CA_155EF7D6824B__INCLUDED_)
