//3456789_123456789_123456789_123456789_123456789_123456789_123456789_123456789_
//
// P2Line.h: interface for the CP2Line class; holds a projective 2-space line,
// consisting of the column vector [e1,e2,e3]^T.  A point P = [x1,x2,x3]^T is 
// on that line iff [e1,e2,e3].dot.[x1,x2,x3]^T = 0.
//
////////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_P2LINE_H__593FDC45_DF61_4753_87F7_71EC00E37EC9__INCLUDED_)
#define AFX_P2LINE_H__593FDC45_DF61_4753_87F7_71EC00E37EC9__INCLUDED_

#include "IBMRvecmat.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CP2Line  
//==============================================================================
// A single line in projective 2-D space; a column vector L=[e1,e2,e3]^T .  Any
// projective 2D point P=[x1,x2,x3]^T on the line will satisfy L^T * P = 0.
{
public:
	Vec3 m_line;
	int m_drawStyle;						// ==0; don't draw;
											// ==1; draw line w/ x3=-1.
											// ==2; draw plane thru origin
											// ==3; draw both line and plane.
	int m_lineColor;						// Color setup# for line.
	int m_planeColor;						// Color setup# for plane

	CP2Line();								// Default constructor
	virtual ~CP2Line();						// Default destructor.
	void drawMe(CquikColor *pLight);		// pLight points to m_light in the
											// CquikGL object (whose drawGL()
											// function calls us).	CP2Line();

};

#endif // !defined(AFX_P2LINE_H__593FDC45_DF61_4753_87F7_71EC00E37EC9__INCLUDED_)
