//3456789_123456789_123456789_123456789_123456789_123456789_123456789_123456789_
//
// P2Point.h: interface for the CP2Point class..
//
// P2Point holds a single point in Projective 2-D space, expressed as a column
// vector [x1,x2,x3]^T.  The 2D position of this point is (x1/x3, x2/x3).
//  See Also: P2Line.h, P2H.h
//
////////////////////////////////////////////////////////////////////////////////
#if !defined(AFX_P2POINT_H__F8A3CB3F_B342_4505_9F99_E86BCD9E2E2E__INCLUDED_)
#define AFX_P2POINT_H__F8A3CB3F_B342_4505_9F99_E86BCD9E2E2E__INCLUDED_

#include "IBMRvecmat.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CP2Point  
//==============================================================================
// A single point in projective 2-D space; a column vector [x1,x2,x3]^T holds
// the 2D position (x1/x3, x2/x3). Be sure to set the m_pLight pointer for each
// instance of this object
{
public:
	Vec3 m_pt;								// holds x1,x2,x3.

	int m_drawStyle;						// ==0; don't draw;
											// ==1; draw point-like box.
											// ==2; draw ray from origin
											// ==3; draw both ray and point.
	int m_ptColor;							// Color setup# for box-like pt.
	int m_rayColor;							// Color setup# for ray from origin

	void drawMe(CquikColor *pLight);		// pLight points to m_light in the
											// CquikGL object (whose drawGL()
											// function calls us).
	void drawCube(float sidelength);		// draw cube-like object.
	CP2Point();
	virtual ~CP2Point();
};

#endif // !defined(AFX_P2POINT_H__F8A3CB3F_B342_4505_9F99_E86BCD9E2E2E__INCLUDED_)
