//3456789_123456789_123456789_123456789_123456789_123456789_123456789_123456789_
//
//	quikGL.h
//
//	CquikGL is a 'wrapper' class for making animated OpenGL programs within 
//	Windows Visual C++ using MFC (Microsoft Foundation Classes).  
//	
//	Step-by-step Instructions to make a simple program with this class:
//
//	1) Create a directory "Proj1" for your project (you can use any name you 
//		wish as a substitute for "Proj1").
//	2) Open Visual C++ and make a new MFC-base project there:
//		--File->New...->Project->MFC AppWizard(.exe)
//	3) Use "Proj1" (or whatever directory name you chose) as project name, and 
//		step thru the AppWizard: choose "Single Document"
//	4) Use default values for everything else; click FINISH to skip to the end,
//		or just keep hitting 'next'.  At FINISH, AppWizard will make a project 
//		and a set of 'skeleton' files for you.  Compile and run; you have a 
//		working Windows app! (but it doesn't do anything yet).
//
//	5) Put a copy of files quikGL.h, quikGL.cpp (and any others you want such
//		as quikMeshImg.cpp, quikMeskImg.h) in your 'Proj1" directory, and
//		add them to the project (Project->Add To Project->Files...
//		(they should then appear in the 'FileView' display).
//	6) Add a member to CProj1View class:  (Bottom left side, "ClassView" tab,
//		right-click on CProj1View, select "Add Member Variable...", enter:
//		Variable Type: CquikGL, Variable Name: m_GLstuff, Access: public.		
//	7) In Proj1.h, file on the line following #include "resource.h", put:
//		#include "quikGL.h"
//	8) Set the compiler to include the OpenGL libraries: On the Menus at top
//		of VC++ window, select Project->Settings..., select Link tab, select 
//		"General" in the drop-down list; in "Object/Library Modules:" type:
//			opengl32.lib glu32.lib glaux.lib 
//	9) Compile and run; you should have zero errors, zero warnings.  If not, go 
//		back and find your mistake before you go any further.
//	9a) !!!BUG CHECK!!! Sometimes adding existing code to a project confuses
//		'ClassView' display (left-hand side, bottom tab). Click 'Proj1 Classes'
//		to expand the display. You should see:CProj1App,CProj1Doc, CProj1View
//		and other classes such as CquikGL. If any are missing (esp. CProj1View)
//		then shut down VC++, delete the 'Proj1.ncb' file, and start VC++ again.
//		(It will re-generate a new Proj1.ncb file, and will find all classes).
//
// 10) Start the Classwizard (View->ClassWizard...), and make a new Windows-
//		message handling function:
//		--on "Message Maps" tab, set "Class Name" drop-down to CProj1View.   
//		--In "Messages" window select "WM_CREATE" and click "Add function"(this
//		  makes a function body), then click 'Edit Code" (this opens the editor
//		  at the function body we just made in CProj1View class).Just after the
//		  "//TODO:Add your..." line in CProj1View::OnCreate() function, type 
//		  these 2 lines:
//			CClientDC clientDC(this);	// Get the Windows GDI 'Device Context'
//			m_GLstuff.OnCreate_GL(clientDC);	// Use it for OpenGL setup.
// 11) Make another windows-message handling function; open Class Wizard again,
//		"Message Maps" tab, "Class Name" dropdown set to Cproj1View, and in
//		"Messages" window select "WM_DESTROY", click "Add Function", and then
//		click "Edit Code".  Again we go to a new function just created.
//		Just after the "//TODO: Add your..." line in CProj1View::OnDestroy()
//		function, type this one line:
//		m_GLstuff.OnDestroy_GL();		// Discard OpenGL's rendering context.
// 12) In proj1View.cpp file, find function CProj1View::PreCreateWindow(), 
//		(How? look at ClassView (lower left, tab), click 'Proj1 Classes' to
//		expand it, click 'CProj1View' to expand that too; double-click the fcn.) 
//		and just after the "//TODO: ..." line, type in this one line:
//		m_GLstuff.PreCreate_GL(cs);		// Create OpenGL's rendering context.
// 13) In proj1View.cpp file, find function CProj1View::OnDraw(), and just 
//		after the "//TODO: ..." line, type in this one line:
//		m_GLstuff.drawOpenGL(pDC);		// Do OpenGL's drawing.
// 14) Compile and run. You should see a gray background with some text & colors.
//		displayed.  If not, go back and fix your mistake before going further.
// 15)	In quikGL.cpp file, edit the 'drawOpenGL()' function to get more
//		interesting results on-screen.  You're on your way!
//
// 16) The CquikGL class uses double-buffering, but Windows by default will
//		'clear' the openGL display window just before calling "OnDraw()". This 
//		causes a white flash between every frame of animation, and slows it to 
//		half-speed. To prevent this white flashing:
//		--Start ClassWizard (View->ClassWizard), MessageMaps tab, Class Name
//		CProj1View, and in Message window select "WM_ERASEBKGND". 
//		Click 'Add fcn" then  "Edit Code".Comment out the line 	
//							return CView::OnEraseBkgnd(pDC);
//		and replace it with		
//							return TRUE;	// no screen clearing!
//
// 17) For animation, CProj1App class must call CquikGL::tick_GL() when it has 
//		idle time between calculations. The RIGHT way to do this is to use the
//		"CProj1App::OnIdle()" fcn, but getting back to Cproj1View() objects is
//		too tricky.  The easy way is to use dumb 'timer' that issues a Windows
//		message every 15 milliseconds: we'll do that in CProj1View class. 
//		--Start ClassWizard (Menu: View->ClassWizard...), select Message Maps,
//		  in Class Name box select CProj1View, in Messages box select"WM_TIMER"
//		  then click "Add Function" and "Edit Code".  Just below "TODO..." line
//		  add these lines:
//		if(m_GLstuff.m_bAnimate==TRUE)		// If we're animating,
//		{
//			m_GLstuff.tick_GL();			// Advance animation by 1 timestep
//			Invalidate(FALSE);				// Trigger windows redrawing.
//		}			
//		--In CProj1View::OnCreate() function, just after 
//				m_GLstuff.OnCreate_GL(clientDC);			
//		add the lines:
//				m_GLstuff.m_bAnimate=TRUE;		// enable animation.
//				CWnd::SetTimer(1,15,NULL);		// Brute-force timer #1;
//		--In Cproj1View::OnDestroy() function, just after
//				m_GLstuff.OnDestroy_GL();		// Kill OpenGL render context.
//		add the line:
//				CWnd::KillTimer(1);				// Shut down animation timer #1.
// Now you'll have a double-buffered animated display.  Every frame time (set 
// by the 'timer' we just added) the program calls 'tickGL()', where you should
// put any time-dependent changes you want to happen, and draw_GL() will draw
// them on-screen.  Compile,run: nothing moves yet, but mouse cursor flickers.
//
// 18) Getting OpenGL to pay attention to viewing matrices requires you to tie
// the openGL rendering context to the ClientDC (Windows Device Context for the
// 'client area' of the display window).  Here's how:
//  Make another windows-message handling function.  
//		Open Class Wizard again, "Message Maps" tab, "Class Name" dropdown set 
//		to Cproj1View, and in "Messages" window select "WM_SIZE", clik "Add 
//		Function", and then click "Edit Code".  Again we go to a new function 
//		just created: CProj1View::OnSize(). 
//		 Just after the "//TODO: Add your..." line, add these lines:
//			CClientDC our_winDC(this);				// Grab Win. Device Context
//													// (to link with OpenGL )
//			m_GLstuff.OnSize_GL(our_winDC,cx,cy);	// Re-set GL viewing matrix.
// 19) Set the default window size: CMainFrame class, in PreCreateWindow() fcn,
//		add these lines just before the 'return' statement:
//			cs.cx = 650;	// set default size of window
//			cs.cy = 700;
// 
// 20) Add ability to open/save files: Open Class Wizard, "Message Maps" tab,
//		CProj1View class, and (DIFFERENT!) in "Object IDs" click "ID_FILE_OPEN"
//		then in "Messages" click COMMAND, then "Add Function" (default file
//		name is OK) then "Edit Function".  Add just one line to it:
//			m_GLstuff.OnFileOpen(CWnd::m_hWnd);		// Custom file Open...
//		Do the same for file save: Class Wizard, "Object IDs" -> "ID_FILE_SAVE"
//		then in "Messages" click COMMAND, then "Add Function" (default file
//		name is OK, then "Edit Function".  Add just one line to it:
//			m_GLstuff.OnFileSave(CWnd::m_hWnd);		// Custom file Save...
//		Do the same for SaveAs: Class Wizard, "Object IDs" -> "ID_FILE_SAVE_AS"
//		then in "Messages" click COMMAND, then "Add Function" (default file
//		name is OK, then "Edit Function".  Add just one line to it:
//			m_GLstuff.OnFileSave(CWnd::m_hWnd);		// Custom file Save...
//
// 21) Add mouse-handling functions to CProj1View:
//		--Start ClassWizard (Menu: View->ClassWizard...), select Message Maps,
//		  in Class Name box select CProj1View, in Messages box select 
//		  "WM_LBUTTONDOWN" then click "Add Function", 
//		  "WM_LBUTTONUP"   then click "Add Function", 
//		  "WM_MOUSEMOVE"   then click "Add Function", and "Edit Code". You'll
//		  be taken to CProj1View functions you made (OnLButtonDown(), etc.)
//
//		--Replace the contents of CProj1View::OnLButtonDown(), with these lines:
//		CWnd *pFocus;					// tmp: which window is active?
//		CClientDC cDC(this);			// get window's drawing area:
//		//
//		CView::OnLButtonDown(nFlags, point); // Always run the Windows' default 
//										 // mouse routine first.
//		// TODO: Add your message handler code here and/or call default
//		pFocus = CWnd::GetFocus();
//		if(pFocus == this)
//		{
//			SetCapture( );  // Capture the mouse until button up
//			m_GLstuff.LButtonDown(cDC, point);	
//							// Now go to user's mouse routines
//		}
//
//		--Replace the contents of CProj1View::OnLButtonUp(), with these lines:
//		// TODO: Add your message handler code here, and/or call default
//		CClientDC cDC(this);			// get window's drawing area:
//		
//			if( GetCapture( ) != this )	// does our window(view) control the mouse?
//			{							// No! mouse isn't ours; run the 
//				CView::OnLButtonUp(nFlags, point);	// Windows default mouse handler.
//				return;
//			}							// Yes. save the mouse position, and
//			m_GLstuff.LButtonUp(cDC,point);	// Make the OpenGL object move around.
//			ReleaseCapture( );			// Release our mouse capture; we're done.
//
//		--Replace the contents of CProj1View::OnMouseMove() with these lines:
//		CClientDC cDC(this);			// get window's drawing area:
//		//
//			if( GetCapture( ) != this )	// We capture ONLY when LButton is down..
//			{							// No! mouse isn't ours; do default stuff.
//				CView::OnMouseMove(nFlags, point);
//				return;
//			}							// Yes. Mouse dragging with left button down.
//										// keep previous mouse position, and
//			m_GLstuff.LMouseDrag(cDC,point);	// call the OpenGL part of program; give it
//										// the current mouse position.
//		--Compile and run.  Mouse dragging should rotate what you see onscreen.
//
// 22) Add keystroke-handling functions to CProj1View:
//		--Start ClassWizard (Menu: View->ClassWizard...), select Message Maps,
//		  in Class Name box select CProj1View, in Messages box select 
//		  "WM_KEYDOWN" then click "Add Function", 
//		  "WM_KEYUP"   then click "Add Function", and "Edit Code". You'll
//		  be taken to CProj1View functions you made (OnKeyDown(), etc.)
//		--Just after the "// TODO: Add ..." line in CProj1View::OnKeyDown() add:
//				m_GLstuff.keyDown_GL(nChar, nRepCnt, nFlags);
//		--Just after the "// TODO: Add ..." line in CProj1View::OnKeyUp() add:
//				m_GLstuff.keyUp_GL(nChar, nRepCnt, nFlags);
//
//	8/31/2002 Jack Tumblin	Created (as implicit surface 'floater' display)
//	9/05/2002 Jack Tumblin	Renamed 'Cswarm' class as 'CdiscSwarm'
// 10/27/2002 Jack Tumblin  Revised 'OnSize_GL()' to set Windows, GL contexts
//							and 'drawOpenGL()' to use lit, shiny polys.
// 11/02/2002 Jack Tumblin  Started mouse-handling functions.
// 03/24/2003 Jack Tumblin	Finished mouse-handling fcns. Texture map tests.
// 04/07/2003 Jack Tumblin	Re-organized; uses CquikAxes,CquikMeshImg classes 
// 04/09/2003 Jack Tumblin  Added FileOpen/Save dialogs.
// 04/22/2003 Jack Tumblin  Added keystroke functions (removed picking mess)
// 04/23/2003 Jack Tumblin  Added CquikColor class to hold lighting/materials
//
////////////////////////////////////////////////////////////////////////////////
#if !defined(AFX_QUIKGL_H__E41B2E29_49EE_4F3A_AC86_8E4563B83B45__INCLUDED_)
#define AFX_QUIKGL_H__E41B2E29_49EE_4F3A_AC86_8E4563B83B45__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <gl\gl.h>			// Master includes for all OpenGL libraries
#include <gl\glu.h>			//
#include <gl\glaux.h>		//

#include "quikColor.h"		// Added by ClassView
#include "P2Line.h"			// Projective 2-space:	line
#include "P2Point.h"		//						point
#include "P2H.h"			//						H matrix.
#include "quikMeshImg.h"	// '3D Rubber sheet' image class

#ifndef M_PI
#define M_PI 3.1415926535897932384626433832795
							// Because Windows doesn't define pi for you,
							// copy it from Calculator: (Start->Programs->
							// ->Accessories->Calculator, View->Scientific,
							// Radians. Push 'pi' button, Edit->Copy)
#endif

// Where do you put your 'drawing routines'? 
//==========================================
// Think Object-oriented; make a class for each kind of object you want to draw,
// include a 'drawMe' member function, and have CquikGL::drawOpenGL() call it
// for a quikGL member variable of that object type.  EXAMPLE: CquikAxes class
// describes 3D axis objects; CquikGL member m_P2axes is one of those objects,
// and CquikGL::drawOpenGL calls m_P2axes.drawMe() to put it on-screen. 
// You can put objects in this file, but its better to make a separate file for
// each new class. In ClassView window, right-click on Proj1, clik 'New Class',
// and follow directions.  The CquikMeshImg class was created that way...
//=========================================================================
// IMPORTANT HINT FOR VISUAL C++:
// Be sure to use Visual Studio's built-in mechanisms for creating new classes,
// member functions, and member variables.  This ensures that openGL will link
// properly to all the new classes you make. To create a new class, in ClassView
// right-click on 'Proj1 classes', choose 'New Class...", and set 'Class type'
// to 'Generic Class', and enter a class name (Win32 uses 'C' prefix for all
// class names).  Visual C++ will create a new .cpp and .h file for you, and
// do all linking housekeeping automatically. (it saves many linking headaches).

class CquikAxes
//==============================================================================
// Draw 3-colored, labeled cartesian axes to show the origin of a coord. system.
{
public:
	CquikAxes();							// Constructor, initializer
	virtual ~CquikAxes();					// Destructor (default)

public:
	CString labl[3];						// Text labels for axes
	CquikColor *m_pLight;					// Ptr to GL lighting/color info.

	void drawMe(GLuint fontID);	
											// call this only from within 
											// CquikGL::drawOpenGL() only.
	void makeCube(float sideLength);		// put a cube at the origin.
	void error_GL(const char *label);		// Report last OpenGL error, if any.
};

class CquikGL
//==============================================================================
// Class to encapsulate many commonplace OpenGL 3D programming tasks in Windows
// and provide working example code for graphics courses at Northwestern Univ.
{
public:
	CquikGL();								// Constructor, initializer
	~CquikGL();								// Destructor (default)

// For mouse movements and actions
	CPoint m_mouseNowPix;				// Mouse location reported from the
										// display window, measured in pixels
										// (valid during a mouse click or drag.)
	CPoint m_mouseStartPix;				// previously used mouseNow value; used
										// in mouse dragging functions.

// For keyboard inputs
	int m_keypress;						// Code for the currently pressed key.
	BOOL m_isShift;						// TRUE while SHIFT key is pressed.

// For animation example:
	BOOL m_bAnimate;					// TRUE==run OpenGL animation, 
										//  FALSE==freeze!

	float m_Xmove,m_Ymove,m_Zmove;		// 'tick_GL' time-dependent variables

// For easy lighting-and-materials control
	CquikColor m_light;					// Current openGL lighting state.

// For on-screen OpenGL text:
	CString m_msg1,m_msg2;				// On-screen text strings
	GLuint m_fontID;					// ID# for 1st of 256 display lists 
										// used for text (one for each letter)
// For error-finding:
	BOOL m_isOK;						// generic internal error flag

// For drawing on-screen axes:
	CquikAxes	m_P2axes;				// Object for P2 projective-space axes

// For a texture-mapped grid of vertices, (a 'billboard').
	CquikMeshImg m_vimg;				// Object for image on a rectangle in 3D

private:
	OPENFILENAME m_file2open;	// all details of user's latest filename choice 
	OPENFILENAME m_file2save;	// all details of user's latest filename choice
	HGLRC m_hRC;			// Handle to the OpenGL rendering context we use
public:
	// WINDOWS calls the fcns below to get your program to do something:
	//==========================================================================
	void PreCreate_GL(CREATESTRUCT& cs);	// see Proj1View::PreCreateWindow()
	void drawOpenGL(CDC* pDC);				// see CProj1View::OnDraw()
	void tick_GL(void);						// Called from CProj1App::OnTimer()
											// to advance 1 timestep.
	void OnCreate_GL(CClientDC& clientDC);	// see CProj1View::OnCreate()
	void OnSize_GL(CClientDC& clientDC, int cx, int cy);
											// Called from CProj1View::OnSize()
											//  to set viewing geometry
	void OnFileOpen(HWND hSrcWin);			// User wants to open a file
	void OnFileSave(HWND hSrcWin);			// User wants to save a file.
	void OnDestroy_GL(void);				// CProj1View::OnDestroy() calls it
											//  for orderly shutdown of OpenGL
	void LButtonDown(CClientDC& clientDC, CPoint pnt);	
											// Valid mouse click started at pnt
											// (called from CProj1View...)
	void LButtonUp(CClientDC& clientDC, CPoint pnt);				
											// Valid mouse click stopped at pnt.
											// (called from CProj1View...)
	void LMouseDrag(CClientDC& clientDC, CPoint pnt);
											// Mouse motion between ButtonDown
											// and LButtonUp (CProj1View...)
	void keyDown(UINT nChar, UINT nRepCnt, UINT nFlags);// User pressed...
	void keyUp(UINT nChar, UINT nRepCnt, UINT nFlags);	// or released a key.
														
//void RButtonDown();
//void RButtonUp();
//void RMouseDrag();
	//
	// YOUR program calls the fcns below to get WINDOWS to do something.
	// (these are rare--most function calls originate from a WINDOWS UI action)
	//=========================================================================
	void error_GL(const char *label);		// Report last openGL error, if any.

	// Projective 2-space drawing.			
	void drawP2point(float x1, float x2, float x3);
	//---------------------------------------USER'S APP. MEMBERS:
};


#endif // !defined(AFX_QUIKGL_H__E41B2E29_49EE_4F3A_AC86_8E4563B83B45__INCLUDED_)
